# SourcePath: libjs/20080409dev
Summary: JavaScript engine
Name: sony-target-dev-libjs
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-libjs
Version: 1.7.0
Release: 08010004
URL: http://ftp.mozilla.org/pub/mozilla.org/js
Source: js-%{version}.tar.gz
Patch: Makefile-ref-%{version}.patch
Patch1: js-powerpc.patch
Patch2: js-fPIC-for-shared-libs.patch
Patch3: libjs_gettimeofday_hook.patch
License: MPL1.1 / GPL2.0 / LGPL2.1
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
Buildroot: %{_tmppath}/%{name}-root
%define targetroot %{sony_target_dir}
Prefix: %{sony_target_dir}


%define _bindir         %{sony_target_dir}%{sony_target_dev_bin_dir}
%define _incdir         %{sony_target_dir}%{sony_target_dev_include_dir}
%define _libdir         %{sony_target_dir}%{sony_target_dev_lib_dir}
%define _mandir         %{sony_target_dir}%{sony_target_dev_man_dir}
%define _infodir        %{sony_target_dir}%{sony_target_dev_info_dir}
# %define _datadir        %{sony_target_dir}%{_hhl_target_sharedstate_dir}
%define _docdir         %{sony_target_dir}%{sony_target_dev_doc_dir}
%define _prefix         %{sony_target_toolprefix}

%description
JS modules declare and implement the JavaScript compiler, interpreter, decompiler,
GC and atom manager, and standard classes.This package includes the shared library.

%package -n %{pkgname}
Summary: JavaScript engine - runtime
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
JS modules declare and implement the JavaScript compiler, interpreter, decompiler,
GC and atom manager, and standard classes.This package includes the shared library.

%prep
%setup -n js  -q
%patch -p1

%if "%{sony_target_cpu}" == "ppc"
%patch1 -p1
%endif
%patch2 -p1
%if "%{sony_target_dialect}" == "thumb2"
%patch3 -p1
%endif

%build

%sony_target_dev_setup
export BUILD_ARCH="%{_prefix}";
cd src

make -f Makefile.ref CC="${CC}" LD="${CC}"
make -C fdlibm -f Makefile.ref CC="${CC}" LD="${CC}"


%install
rm -rf %{buildroot}
%sony_target_dev_setup

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}

export HHL_PREFIX=%{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}

install -m 755 src/Linux_All_DBG.OBJ/libjs.so %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libjs.so

install -m 644 src/Linux_All_DBG.OBJ/libjs.a %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libjs.a
install -m 755 src/editline/Linux_All_DBG.OBJ/libedit.a %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libedit.a
install -m 644 src/fdlibm/Linux_All_DBG.OBJ/libfdm.a %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libfdm.a
install -m 644 src/jsapi.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jsstddef.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jsautocfg.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jscompat.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jslong.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jsosdep.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jsotypes.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jspubtd.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jstypes.h %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
install -m 644 src/jsproto.tbl %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}

install -m 755 src/Linux_All_DBG.OBJ/js %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/
install -m 755 src/Linux_All_DBG.OBJ/jscpucfg %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/


# 6.x
for b in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}`; do
    case $b in
        *-config)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/$b \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}`; do
    case $l in
        *.a|pkgconfig)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
    if [ "$l" != "pkgconfig" ]; then
        ln -s ../../..%{sony_target_devtool_lib_dir}/$l \
            %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
    fi
done


%clean
rm -rf %{buildroot}


%files -n %{pkgname}
%defattr(-,root,root)
%{_libdir}/libjs.so
%{_libdir}/libjs.a
%{_libdir}/libedit.a
%{_libdir}/libfdm.a
%{_incdir}/jsapi.h
%{_incdir}/jsstddef.h
%{_incdir}/jsautocfg.h
%{_incdir}/jscompat.h
%{_incdir}/jslong.h
%{_incdir}/jsosdep.h
%{_incdir}/jsotypes.h
%{_incdir}/jspubtd.h
%{_incdir}/jstypes.h
%{_incdir}/jsproto.tbl
%{_bindir}/js
%{_bindir}/jscpucfg

%{sony_target_dir}%{sony_target_devtool_lib_dir}/libjs.a
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libedit.a
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libfdm.a

%changelog
* Mon Nov 07 2011 Sony Corporation 
- Added gettimeofday hook function

* Wed Oct 27 2010 Sony Corporation
- Added -fPIC patch for shared libs build

* Thu May 08 2008 Sony Corporation
- version-up 1.60 -> 1.7.0

* Wed Aug 29 2007 Sony Corporation
- Integrated CE3.x and CE4.x.

* Mon Jun 18 2007 Sony Corporation
- CE3.X: added ppc build CFLAG.

* Fri May 18 2007 Sony Corporation
- Initial build.
